#ifndef NBODYSIM_H
#define NBODYSIM_H

#include <string>

class nBodySim {
public:
    // constructor reads in data from datafile
    nBodySim(std::string& datafile);
    // destructor deletes arrays 
    ~nBodySim();
    // loops over all pairs of particles and calculates forces
    void calculateForces();
    double* getMasses() { return masses_; }
    double* getPositions() { return positions_; }
    double* getForces() { return forces_; }
    // writes data to file, every row is a particle
    void write2file(const double* array, std::string filename, unsigned dim) const;
    unsigned getN() const { return N_; }
private:
    unsigned N_;
    // 3d vectors are stored as a 1d array of length 3*N_ in the format x1, y1, z1, x2, y2, z2, ...
    double* masses_;
    double* positions_;
    double* velocities_;
    double* softening_;
    double* potential_;
    double* forces_;
};

#endif /* NBODYSIM_H */